> For the complete documentation index, see [llms.txt](https://docs.2checkout.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.2checkout.com/shopping-carts/inline/use-cases/add-a-dynamic-product-to-the-inline-cart.md).

# Add a dynamic product to the InLine Cart

## Overview

Use the **Product** object to add a dynamic product to the InLine Cart by calling the click event handler.

## Use case

1. Add an HTML link or button in your page like the one below.
2. Create a JavaScript click handler to execute the Inline Client desired methods.
3. Use the `TwoCoInlineCart.setup.setMode('DYNAMIC')` method in order to let the cart know you are using dynamic instead of catalog products.
4. In order to set currency use `TwoCoInlineCart.cart.setCurrency(currency-code)`.
5. Add your product to the cart by calling the `TwoCoInlineCart.products.add({name, quantity, price, options})` method.
6. You can see below a signature token request payload for this example. A success response contains a JSON with the property “signature“ which needs to be used at the next step to set the signature using the `TwoCoInlineCart` method.<br>

   ```javascript
   {
       "merchant": "2COLRNC",
       "dynamic": "1",
       "currency": "USD",
       "products": [
           {
               "name"    : "A test dynamic product",
               "quantity": 1,
               "price"   : 20
           }
       ]
   }
   ```

   \
   The above payload will generate the signature 718e810fee34be2bf4b9d4582323aa37580c4011ef694116cca5b0bb7badd2f1.
7. Use the `TwoCoInlineCart.cart.setSignature('718e810fee34be2bf4b9d4582323aa37580c4011ef694116cca5b0bb7badd2f1')` method to set the signature. It is important that you employ `TwoCoInlineCart.cart.removeAll()` just before the `TwoCoInlineCart.products.addMany(products)` or `TwoCoInlineCart.products.add(product)` methods to remove previous products as the signature is based on the products' definition.
8. Use the `TwoCoInlineCart.cart.checkout()` method to show the cart on your page.

## Sample request

### HTML

```html
<a href="#" class="btn btn-success" id="buy-button">Buy now!</a>
```

### JavaScript

```javascript
window.document.getElementById('buy-button').addEventListener('click', function() {
  TwoCoInlineCart.setup.setMode('DYNAMIC');
  TwoCoInlineCart.cart.setCurrency('USD');

  TwoCoInlineCart.products.add({
    name: 'A test dynamic product',
    quantity: 1,
    price: 20,
  });
  TwoCoInlineCart.cart.setSignature('718e810fee34be2bf4b9d4582323aa37580c4011ef694116cca5b0bb7badd2f1');
  TwoCoInlineCart.cart.checkout();
});
```

## Demo

After adding the dynamic product to the InLine checkout using the above method, your cart should look like this.

{% embed url="<https://codepen.io/2checkout-documentation/pen/pXvBPB>" %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.2checkout.com/shopping-carts/inline/use-cases/add-a-dynamic-product-to-the-inline-cart.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
